Package org.apache.synapse.transport.passthru

# Class TargetResponse

java.lang.Object
org.apache.synapse.transport.passthru.TargetResponse

public class TargetResponse extends Object
This class represents a response coming from the target server.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TargetResponse(TargetConfiguration targetConfiguration, org.apache.http.HttpResponse response, org.apache.http.nio.NHttpClientConnection conn, boolean expectResponseBody, boolean forceShutdownConnectionOnComplete)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addExcessHeader(org.apache.http.Header h)`
  `ByteBuffer`
  `copyAndRead(org.apache.http.nio.NHttpClientConnection conn, org.apache.http.nio.ContentDecoder decoder)`
  Same as `read(org.apache.http.nio.NHttpClientConnection, org.apache.http.nio.ContentDecoder)` but gives out the data read from the wire in to the pipe.
  `org.apache.http.nio.NHttpClientConnection`
  `getConnection()`
  `Map`
  `getExcessHeaders()`
  `String`
  `getHeader(String name)`
  `Map<String,String>`
  `getHeaders()`
  `Pipe`
  `getPipe()`
  `int`
  `getStatus()`
  `String`
  `getStatusLine()`
  `org.apache.http.ProtocolVersion`
  `getVersion()`
  `boolean`
  `isExpectResponseBody()`
  `boolean`
  `isForceShutdownConnectionOnComplete()`
  `int`
  `read(org.apache.http.nio.NHttpClientConnection conn, org.apache.http.nio.ContentDecoder decoder)`
  Read the data from the wire and read in to the pipe so that other end of the pipe can write.
  `void`
  `start(org.apache.http.nio.NHttpClientConnection conn)`
  Starts the response

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TargetResponse

    public TargetResponse(TargetConfiguration targetConfiguration, org.apache.http.HttpResponse response, org.apache.http.nio.NHttpClientConnection conn, boolean expectResponseBody, boolean forceShutdownConnectionOnComplete)

- ## Method Details

  - ### start

    public void start(org.apache.http.nio.NHttpClientConnection conn)
    Starts the response
    Parameters:
      `conn` - the client connection

  - ### read

    public int read(org.apache.http.nio.NHttpClientConnection conn, org.apache.http.nio.ContentDecoder decoder) throws IOException
    Read the data from the wire and read in to the pipe so that other end of the pipe can write.
    Parameters:
      `conn` - the target connection
      `decoder` - content decoder
    Returns:
      number of bites read
    Throws:
      `IOException` - if an error occurs

  - ### copyAndRead

    public ByteBuffer copyAndRead(org.apache.http.nio.NHttpClientConnection conn, org.apache.http.nio.ContentDecoder decoder) throws IOException
    Same as `read(org.apache.http.nio.NHttpClientConnection, org.apache.http.nio.ContentDecoder)` but gives out the data read from the wire in to the pipe.
    Parameters:
      `conn` - the target connection
      `decoder` - content decoder
    Returns:
      data read
    Throws:
      `IOException` - if an error occurs

  - ### getHeader

    public String getHeader(String name)

  - ### getHeaders

    public Map<String,String> getHeaders()

  - ### getExcessHeaders

    public Map getExcessHeaders()

  - ### addExcessHeader

    public void addExcessHeader(org.apache.http.Header h)

  - ### getPipe

    public Pipe getPipe()

  - ### getStatus

    public int getStatus()

  - ### getStatusLine

    public String getStatusLine()

  - ### isExpectResponseBody

    public boolean isExpectResponseBody()

  - ### getConnection

    public org.apache.http.nio.NHttpClientConnection getConnection()

  - ### getVersion

    public org.apache.http.ProtocolVersion getVersion()

  - ### isForceShutdownConnectionOnComplete

    public boolean isForceShutdownConnectionOnComplete()